<?php

class installer {

	public $version = 112;
	public $config = null;
	public $step = 1;
	public $secure = null;
	public $extensions_data = array(
		"curl"     => "php extension: cURL",
		"mysqli"   => "php extension: MySQLi",
		"mbstring" => "php extension: mbstring",
		"gd"       => "php extension: gd",
		"php"      => "php 5.6 or higher",
		"url_open" => "allow_url_fopen enabled in php config"
	);
	public $messages = [];

	public function __construct(){

		require_once( root . "/app/core/class_secure.php" );
		$this->secure = new secure( $this );

		$this->_read_config_file();
		$this->set_step();

	}

	public function set_step(){

		if (
			!empty( $this->config["db_host"] ) &&
			!empty( $this->config["db_user"] ) &&
			!empty( $this->config["db_pass"] ) &&
			!empty( $this->config["db_name"] ) &&
			!empty( $this->config["web_addr"] ) &&
			!empty( $this->config["purchase_code"] ) &&
			!empty( $this->config["client_code"] ) &&
			!empty( $this->config["sign_code"] ) &&
			$this->check_database()["all_ready"]
		){
			$this->step = 6;
		}

		elseif (
			!empty( $this->config["db_host"] ) &&
			!empty( $this->config["db_user"] ) &&
			!empty( $this->config["db_pass"] ) &&
			!empty( $this->config["db_name"] ) &&
			!empty( $this->config["web_addr"] ) &&
			!empty( $this->config["purchase_code"] ) &&
			!empty( $this->config["client_code"] ) &&
			empty( $this->config["sign_code"] ) &&
			!empty( $_POST["step5"] ) &&
			!empty( $_POST["admin_email"] ) &&
			!empty( $_POST["admin_password"] )
		){

			$this->step = 5;
			if ( $this->check_admin_credits() ){
				$this->update_config();
			    $this->update_database();
			    $this->update_database_user();
			    $this->sign_purchase_code();
			    $this->step = 6;
			}

		}

		else if (
			!empty( $this->config["db_host"] ) &&
			!empty( $this->config["db_user"] ) &&
			!empty( $this->config["db_pass"] ) &&
			!empty( $this->config["db_name"] ) &&
			!empty( $this->config["web_addr"] ) &&
			!empty( $this->config["purchase_code"] ) &&
			!empty( $this->config["client_code"] ) &&
			empty( $this->config["sign_code"] )
		) {
			$this->step = 5;
		}

		else if ( empty( $_POST["step4"] ) ? false :
			$_POST["step4"] === "Continue" &&
			!empty( $this->config["db_host"] ) &&
			!empty( $this->config["db_user"] ) &&
			!empty( $this->config["db_pass"] ) &&
			!empty( $this->config["db_name"] ) &&
			!empty( $this->config["web_addr"] ) &&
			empty( $this->config["purchase_code"] ) &&
			empty( $this->config["client_code"] ) &&
			empty( $this->config["sign_code"] ) &&
			!empty( $_POST["purchase_code"] ) &&
			!empty( $_POST["email"] )
		) {
			$this->update_config();
			$this->step = 4;
			if ( !empty( $this->config["purchase_code"] ) && !empty( $this->config["client_code"] ) )
				$this->step = 5;

		}

		else if (
			!empty( $this->config["db_host"] ) &&
			!empty( $this->config["db_user"] ) &&
			!empty( $this->config["db_pass"] ) &&
			!empty( $this->config["db_name"] ) &&
			!empty( $this->config["web_addr"] )
		) {
			$this->step = 4;
		}

		else if (
			isset( $_POST["db_user"] ) &&
			isset( $_POST["db_pass"] ) &&
			isset( $_POST["db_host"] ) &&
			isset( $_POST["db_name"] ) &&
			isset( $_POST["web_addr"] )
		) {
			$this->step = 3;
			$this->update_config();
		}

		else if (
			!empty( $this->config["db_host"] ) ||
			!empty( $this->config["db_user"] ) ||
			!empty( $this->config["db_pass"] ) ||
			!empty( $this->config["db_name"] ) ||
			!empty( $this->config["web_addr"] )
		) {
			 $this->step = 3;
		}

		else if ( !empty( $_POST["step2"] ) ? $_POST["step2"] === "Continue" : false ){
			$this->step = 3;
		}

		else if ( !empty( $_POST["step1"] ) ? $_POST["step1"] === "Agree" : false ){
			$this->step = 2;
		}

	}

	public function check_admin_credits(){

		if ( !$this->secure->get( "post", "admin_email", "email" ) ){
			$this->messages[] = [ 0, "Invalid email" ];
			return false;
		}

		if ( !$this->secure->get( "post", "admin_password", "password" ) ){
			$this->messages[] = [ 0, "Invalid password" ];
			return false;
		}

		return true;

	}
	public function check_files(){

		if ( !is_file( iroot . "/__sources/__files_list.txt" ) )
			die(  iroot . "/__sources/__files_list.txt is missing" );

		$files_list = json_decode( file_get_contents( iroot . "/__sources/__files_list.txt" ), 1 );
		if ( !is_array( $files_list ) )
			die(  iroot . "/__sources/__files_list.txt is damaged" );

		foreach( $files_list as $file_path ){

			if ( !is_file( root . "/{$file_path}" ) )
				$bad_files[] = $file_path;

		}

		return array(
			"all_ready" => true,
			"bad"       => false
		);

	}
	public function check_extensions(){

		$functions = [
			"curl"     => false,
			"mysqli"   => false,
			"mbstring" => false,
			"gd"       => false,
			"php"      => false,
			"url_open" => false
		];

		if ( function_exists( "curl_init" ) )
			$functions["curl"] = true;

		if ( function_exists( "mysqli_connect" ) )
			$functions["mysqli"] = true;

		if ( extension_loaded( "mbstring" ) )
			$functions["mbstring"] = true;

		if ( extension_loaded( "gd" ) || function_exists( "gd_info" ) )
			$functions["gd"] = true;

		if ( version_compare( PHP_VERSION, '5.6.0', '>=' ) )
			$functions["php"] = true;

		if ( ini_get('allow_url_fopen') )
			$functions["url_open"] = true;

		return array(
			"all_ready" => count( $functions ) == array_sum( $functions ),
			"functions" => $functions
		);

	}
	public function check_purchase_code( $code, $admin_email = null ){

		$boac = new boac( null,[
			"purchase_code" => $code
		] );

		$get_cc = $boac->get_cc( $admin_email, $this->version );

		if ( !$get_cc["sta"] )
			return [ "all_ready" => false ];

		return [ "all_ready" => true, "cc" => $get_cc["data"] ];

	}
	public function check_database(){

		$db = mysqli_connect( $this->config['db_host'], $this->config['db_user'], $this->config['db_pass'], $this->config['db_name'] );

		$all_ready = true;

		foreach( explode( ",", "_curl_cache,_users" ) as $_table_name ){
			if ( !mysqli_query( $db, "SELECT 1 FROM {$_table_name}" ) )
				$all_ready = false;
		}

		return [ "all_ready" => $all_ready ];

	}
	public function sign_purchase_code(){

		$check_extensions    = $this->check_extensions();
		$check_files         = $this->check_files();

		if ( !$check_extensions["all_ready"] || !$check_files["all_ready"] )
			die("Something went wrong. Please re-upload installation folder and start from beginning");

		$domain = str_replace( "www.", "", parse_url( $this->config["web_addr"], PHP_URL_HOST ) );
		$this->config["sign_code"] = md5(crc32( $domain . $this->config["purchase_code"] ));
		$this->_write_config_file();

	}

	public function update_config(){

		// Purchase code is changed/submitted. verify it
		if ( !empty( $_POST["purchase_code"] ) &&
			 !empty( $_POST["email"] ) ?
			   $_POST["purchase_code"] !== $this->config["purchase_code"]
			: false )
		{

      $sent_email = $_POST["email"];
		  $sent_pc = $_POST["purchase_code"];

			// Validate && Sanitize email
			if ( !$this->secure->validate( $sent_email, "email", [ "check_dns" => false ] ) ){
			    $this->messages[] = [ 0, "Invalid email" ];
	    	}
			// Validate && Sanitize purchase code
			elseif ( !$this->secure->validate( $sent_pc, "string", [ "strict" => true, "strict_regex" => "[0-9a-zA-Z-]", "min_length" => 36, "max_length" => 36 ] ) ){
				$this->messages[] = [ 0, "Invalid purchase code" ];
			}
			// Validate purchase code against API server
			else {

				$this->config["purchase_code"] = null;
				$check_purchase_code = $this->check_purchase_code( $sent_pc, $sent_email );
				if ( $check_purchase_code[ "all_ready" ] ){
					$this->config["purchase_code"] = $sent_pc;
					$this->config["client_code"] = $check_purchase_code["cc"];
					$this->messages[] = [ 1, "Purchase code was successfully updated. Click on continue" ];
				} else {
					$this->messages[] = [ 0, "Purchase code is invalid/used" ];
				}

			}

		}

		// Web Address is changed/submitted
		if ( !empty( $_POST["web_addr"] ) ? $_POST["web_addr"] != $this->config["web_addr"] : false ){

			$this->config["web_addr"] = null;
      $sent_web_address = $_POST["web_addr"];

			// Validate && Sanitize website address
			if ( $this->secure->validate( $sent_web_address, "url", [ "check_dns" => false ] ) ){
				$this->config["web_addr"] = substr( $sent_web_address, -1 ) == "/" ? $sent_web_address : "{$sent_web_address}/";
		    	$this->messages[] = [ 1, "Web-Address was successfully updated" ];
			} else {
				$this->messages[] = [ 0, "Web-Address is invalid" ];
			}

		}

		// Database
		// validate && sanitize presented database information
		if (
      ( $sent_db_host = $this->secure->get( "post", "db_host", "string", [ "strict" => true, "strict_regex" => "[a-zA-Z0-9\-._]" ] ) ) &&
			( $sent_db_user = $this->secure->get( "post", "db_user", "username", [ "min_length" => 2 ] ) ) &&
			( $sent_db_pass = $this->secure->get( "post", "db_pass", "password" ) ) &&
			( $sent_db_name = $this->secure->get( "post", "db_name", "string", [ "strict" => true, "strict_regex" => "[a-zA-Z0-9\-._]" ] ) )
		){

			if (
				$sent_db_host != $this->config["db_host"] ||
			  $sent_db_user != $this->config["db_user"] ||
			  $sent_db_pass != $this->config["db_pass"] ||
			  $sent_db_name != $this->config["db_name"]
			){

					$this->config["db_name"] = $this->config["db_host"] = $this->config["db_user"] = $this->config["db_pass"] = null;

					// Try to connect to mysql database
					// Catch any error and display it to user on line 345 of this file
					try {
						mysqli_connect( $sent_db_host, $sent_db_user, $sent_db_pass, $sent_db_name );
					} catch( Exception $err ){
						$mysql_error = $err;
					}

					// test given variables to see if we can actually connect to a database
					if ( !mysqli_connect_errno() ){
						$this->config["db_host"] = $sent_db_host;
						$this->config["db_user"] = $sent_db_user;
						$this->config["db_pass"] = $sent_db_pass;
						$this->config["db_name"] = $sent_db_name;
						$this->messages[] = [ 1, "Database connection data successfully updated" ];
					} else {
						$this->messages[] = [ 0, "Database connection failed: " . mysqli_connect_error() . "<BR>" . $mysql_error ];
					}

			}

		}

		$this->_write_config_file();

		if (
			!empty( $this->config["db_host"] ) &&
			!empty( $this->config["db_user"] ) &&
			!empty( $this->config["db_pass"] ) &&
			!empty( $this->config["db_name"] ) &&
			!empty( $this->config["web_addr"] )
		) {
			$this->step = 4;
		}

	}
	public function update_database(){

		$sql_lines = explode( PHP_EOL, str_replace( [ "\n", "\r\n" ], PHP_EOL, file_get_contents( iroot . "/__sources/digimuse.sql" ) ) );
		if ( !is_array( $sql_lines ) || empty( $sql_lines ) || count( $sql_lines ) < 800 ) die( "<b>".iroot."/__sources/digimuse.sql</b> is damaged-1. Re-upload the installer and start from beginning" );

		$query_lines = [];
		$query_line = "";
		foreach( $sql_lines as $sql_line ){

			$sql_line = trim( $sql_line );
			if ( empty( $sql_line ) ) continue;
			if ( strlen( $sql_line ) <= 3 ) continue;
			if ( substr( $sql_line, 0, 2 ) == "--" ) continue;

			// is this line a full query?
			$query_line .= $sql_line;
			if ( substr( $sql_line, -1 ) == ";" ){
				$query_lines[] = substr( $query_line, 0, -1 );
				$query_line = "";
			}

		}

		$db = mysqli_connect( $this->config['db_host'], $this->config['db_user'], $this->config['db_pass'], $this->config['db_name'] );

		// Run query lines
		foreach( $query_lines as $query_line ){
			mysqli_query( $db, $query_line );
		}

	}
	public function update_database_user(){

		// validate && sanitize given password
		if ( !( $sent_admin_password = $this->secure->get( "post", "admin_password", "password" ) ) )
            die("Reload the page. Use a stronger password");

		// validate && sanitize given email
		if ( !( $sent_admin_email = $this->secure->get( "post", "admin_email", "email" ) ) )
			die("Reload the page. User a valid email");

		$db = mysqli_connect( $this->config['db_host'], $this->config['db_user'], $this->config['db_pass'], $this->config['db_name'] );

		$hashed_password = password_hash( $sent_admin_password, PASSWORD_BCRYPT );

		mysqli_query( $db, "INSERT INTO `_users` ( `ID`, `GID`, `username`, `name`, `password`, `email`, `external_addresses`, `avatar`, `artist`, `artist_code`, `verified`, `verify_code`, `fund`, `followers`, `followings`, `feed_setting`, `time_add`, `time_verify`, `time_paid_expire` ) VALUES ( 1, 1, 'admin', 'admin', '{$hashed_password}', '{$sent_admin_email}', NULL, NULL, NULL, NULL, 1, NULL, 0, 0, 0, NULL, now(), now(), NULL )" );

		mysqli_query( $db, "INSERT INTO _setting_admin ( var, val ) VALUES ( 'version', '{$this->version}' )" );

	}
	public function check_database_time(){

		$db = new MySQLi( $this->config['db_host'], $this->config['db_user'], $this->config['db_pass'], $this->config['db_name'] );
		$query = $db->query( "SELECT now() as n" );
		$results = $query->fetch_assoc();
		return reset( $results );

	}

	protected function _read_config_file(){

		require( root . "/app/config.php" );
		return $this->config = [
			"session_check_ratio" => session_check_ratio,
			"purchase_code"       => purchase_code,
			"client_code"         => client_code,
			"sign_code"           => sign_code,
			"web_addr"            => web_addr,
			"db_host"             => db_host,
			"db_user"             => db_user,
			"db_pass"             => db_pass,
			"db_char"             => db_char,
			"db_name"             => db_name,
		];

	}
	protected function _write_config_file(){

		// Update the config file
		$sample = file_get_contents( iroot . "/__sources/__config_sample.txt" );
		foreach( $this->config as $__k => $__v ){
			$sample = str_replace( "\${$__k}\$", $__v, $sample );
		}

		file_put_contents( root . "/app/config.php", $sample );

	}

}

?>
