<?php

ini_set( "memory_limit", "-1" );
set_time_limit( 0 );
error_reporting(E_ALL);
ini_set('display_errors', 'on');
ini_set("xdebug.var_display_max_children", '-1');
ini_set("xdebug.var_display_max_data", '-1');
ini_set("xdebug.var_display_max_depth", '-1');

$iroot = realpath( dirname(__FILE__) );
$root  = realpath( dirname( $iroot ) );
define( "iroot", $iroot );
define( "root", $root );

if ( !is_file( "{$iroot}/__sources/class_installer.php" ) )
	die("Installer is damaged");

if ( !is_readable( "{$iroot}/__sources/class_installer.php" ) )
	die("<b>{$iroot}/class_installer.php</b> is restricted. We recommend giving your web server read/write access to <b class='cr'>{$root}</b> and its subfolders or at least the file mentioned");

if ( !is_readable( "{$iroot}/__sources/__config_sample.txt" ) )
	die("<b>{$iroot}/config_sample.txt</b> is restricted. We recommend giving your web server read/write access to <b class='cr'>{$root}</b> and its subfolders or at least the file mentioned");

if ( !is_readable( "{$iroot}/__sources/digimuse.sql" ) )
	die("<b>{$iroot}/__sources/digimuse.sql</b> is restricted. We recommend giving your web server read/write access to <b class='cr'>{$root}</b> and its subfolders or at least the file mentioned");

if ( !is_readable( "{$root}/app/config.php" ) || !is_writable( "{$root}/app/config.php" ) )
	die("No access to <b>{$root}/app/config.php</b>. Make sure your web server has access to it");

require_once( "{$iroot}/__sources/class_installer.php" );
require_once( "{$root}/app/core/class_boac.php" );
$installer = new installer();

?><!doctype html>
<html>
<head>

  <meta charset="utf-8">
  <title>DigiMuse Installer</title>

  <link href='../themes/__default/assets/third/bootstrap-4.6.0-dist/css/bootstrap.min.css' rel='stylesheet' media='all' type='text/css'>
  <link href='__sources/style.css' rel='stylesheet' media='all' type='text/css'>

</head>
<body class="step_<?php echo $installer->step; ?>">
  <div class="form_wrapper">
  <form method="post">

    <?php if ( $installer->messages ) : foreach( $installer->messages as $__msg ) : ?>
    <div class="alert alert-<?php echo $__msg[0] ? "success" : "danger" ?>"><?php echo $installer->secure->escape( $__msg[1] ); ?></div>
    <?php endforeach; endif; ?>

    <?php if ( $installer->step == 1 ) : ?>

      Hi there. Thanks for choosing DigiMuse. Please read our terms of using DigiMuse then continue to install the script and start your awesome website
      <ul>
  	    <li>You can use this script on <b>1 public domain name only</b>. additional license purchase is required for each new domain</li>
  	    <li>You can't sell, trade or give away this script</li>
      </ul>
      That's it!
      <div class="button_wrapper"><input name="step1" type="submit" value="Agree" class="btn btn-primary"></div>

    <?php elseif ( $installer->step == 2 ) :
	$check_extensions = $installer->check_extensions();
	$check_files = $installer->check_files(); ?>

      <?php if ( $check_extensions["all_ready"] && $check_files["all_ready"] ) : ?>
      <div class="taj">Extensions and files checked. We have everything we need. Press the button to continue</div>
      <?php else : ?>
      <div class="taj">Unfortunately you can't continue the installation until you have fixed the problem</div>
      <?php endif; ?>

      <div class="features">
      	<?php foreach( $check_extensions["functions"] as $extension_name => $extension_status ) : ?>
      	<div class="feature">
      	  <div class="extension_name"><?php echo $installer->secure->escape( $extension_name ); ?></div>
      	  <div class="extension_detail"><?php echo $installer->secure->escape( $installer->extensions_data[ $extension_name ] ); ?></div>
      	  <div class="extension_status <?php echo $extension_status ? "green" : "red"; ?>"><?php echo $extension_status ? "Installed" : "Missing"; ?></div>
      	</div>
      	<?php endforeach; ?>
      	<div class="feature">
      	  <div class="extension_name">files</div>
      	  <div class="extension_detail">application files</div>
      	  <div class="extension_status <?php echo $check_files["all_ready"] ? "green" : "red"; ?>"><?php echo $check_files["all_ready"] ? "Verified" : "Missing:<br>" . implode( "<BR>", $check_files["bad"] ); ?></div>
      	</div>
      </div>

      <?php if ( $check_extensions["all_ready"] && $check_files["all_ready"] ) : ?>
      <div class="button_wrapper"><input name="step2" type="submit" value="Continue" class="btn btn-primary"></div>
      <?php endif; ?>

    <?php elseif ( $installer->step == 3 ) : ?>

      Please create a new mysql database and user. Give user access to database. Enter your mysql data

      <div class="form-group" class="m30t">
        <label>Website Address</label>
        <input name="web_addr" type="url" value="<?php echo $installer->secure->escape( $installer->config["web_addr"] );  ?>" class="form-control">
        <small class="form-text text-muted"><b>Careful:</b> Your purchase code will be used on this domain and this action is not reversible so double check the address. It should start with http or https for example:<br><br>http://domain.com/<br>https://busyowl.co<br>https://digimuse.busyowl.co</small>
      </div>

      <div class="form-group" >
        <label>SQL host</label>
        <input name="db_host" type="text" value="<?php echo $installer->secure->escape( $installer->config["db_host"] ); ?>" class="form-control" >
        <small class="form-text text-muted">You can use `localhost` unless you are using a remote database</small>
      </div>

      <div class="form-group">
        <label>SQL username</label>
        <input name="db_user" type="text" value="<?php echo $installer->secure->escape( $installer->config["db_user"] ); ?>" class="form-control">
      </div>

      <div class="form-group">
        <label>SQL password</label>
        <input name="db_pass" type="text" value="<?php echo $installer->secure->escape( $installer->config["db_pass"] ); ?>" class="form-control">
        <small class="form-text text-muted">Can't be empty. You can't use a user with no password</small>
      </div>

      <div class="form-group">
        <label>SQL database name</label>
        <input name="db_name" type="text" value="<?php echo $installer->secure->escape( $installer->config["db_name"] ); ?>" class="form-control">
      </div>

      <div class="button_wrapper"><input name="step3" type="submit" value="Continue" class="btn btn-primary"></div>

    <?php elseif ( $installer->step == 4 ) : ?>

      App has access to database. Now copy your purchase code from Codecanyon and enter it here

      <div class="taj m30b"></div>

	  <div class="form-group">
        <label>Purchase code</label>
        <input name="purchase_code" type="text" value="<?php echo $installer->secure->escape( $installer->config["purchase_code"] ); ?>" class="form-control">
        <small class="form-text text-muted">Copy your purchase code from Codecanyon and paste it here</small>
      </div>

      <div class="form-group">
        <label>License owner email</label>
        <input name="email" type="email" value="<?php echo $installer->secure->escape( $installer->secure->get( "post", "email", "email" ) ); ?>" class="form-control">
        <small class="form-text text-muted"><b>Careful:</b> This email will be set as the owner of the entered purchased code. You can use this email to login into Busyowl support center so double check email before taking the next step</small>
      </div>

      <div class="button_wrapper"><input name="step4" type="submit" value="Continue" class="btn btn-primary"></div>

    <?php elseif ( $installer->step == 5 ) : ?>

	  Installation is almost done. Now app just needs to create database tables. It might take a few seconds to a few minutes depending on your server. Please click on `Create table` and wait
	  <br><br><br>

      <div class="form-group">
        <label>Admin email</label>
        <input name="admin_email" type="text" value="<?php echo $installer->secure->escape( $installer->secure->get( "post", "admin_email", "email" ) ); ?>" class="form-control">
      </div>

      <div class="form-group">
        <label>Admin password</label>
        <input name="admin_password" type="text" value="<?php echo $installer->secure->escape( $installer->secure->get( "post", "admin_password", "password" ) ); ?>" class="form-control">
      </div>

      <div class="button_wrapper"><input name="step5" type="submit" value="Continue" class="btn btn-primary"></div>

    <?php elseif ( $installer->step == 6 ) : ?>

      <div class="alert alert-success">All Done. Thank you</div>
      DigiMuse is installed on your server and it is ready to use however you still need to take some extra steps to secure your installation

      <ul>
      	<li>Your php and mysql-server should be on same timezone. compare them and <b>make sure</b> they are same. your database current time: <b><?php echo $installer->check_database_time(); ?></b> . your php current time: <b><?php echo date('Y-m-d H:i:s'); ?></b></li>
      	<li>Installation is finished and the installer is not doing anything anymore, however we highly recommend you to erase this directory</li>
      	<li>
      	  Nobody should be able to see the content of these directories. Check them to make sure .htaccess is working and access is restricted
      	  <ol>
      	  	<li><?php echo $installer->config["web_addr"]; ?>app</li>
      	  	<li><?php echo $installer->config["web_addr"]; ?>uploads/uploading</li>
      	  	<li><?php echo $installer->config["web_addr"]; ?>uploads/protected</li>
      	  </ol>
      	</li>
		<li>
		  We are at your service. If you have any question, suggestion, problem or feedback, please visit <a target="_blank" href="https://support.busyowl.co">our support center</a>, login with your email and submit a ticket. We'll get back to you ASAP!
		</li>
      </ul>

	  <div class="button_wrapper"><a class="btn btn-primary" href="<?php echo $installer->config["web_addr"]; ?>">Visit your website</a></div>

    <?php endif; ?>

  </form>
  </div>
</body>
</html>
